package Security::exports;

use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() &check() &print() );

our (%exports);

sub init {
	printf STDERR "Need to define \$showmount in Security::$^O.pm\n"
		if ( ! defined $main::showmount );
}

# Check to see what hosts have filesystems exported to the world.  This 
# idea comes from the HP-UX System Security manual
sub check {
	local *FP;
	my ($dir, $dummy);

	print ( STDERR "In Security::exports::check()\n") if ( $main::opts{'d'} );
	if ( -f $main::showmount ) {
		open(FP, "$main::showmount -e localhost 2>/dev/null |") || die "Could not run $main::showmount";
		while (<FP>) {
			chop;
			$dummy = $_;
			$dummy =~ s/^.* //o;
			$dir = $_;
			$dir =~ s/ .*$//o;
			$exports{$dir} = 1 if ($dummy =~ /\(everyone\)/o);
		}
		close FP;
	}
}

sub print {
	print ( STDERR  "In Security::exports::print()\n") if ( $main::opts{'d'} );

	&main::print_data ("\n\nchecking for world exported filesystems:\n", %exports);
}

1;
