package Security::find;

use File::Find;
use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() &check() &add_wanted() &get_stat());

our ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$curbytes);
our (@funcs, %stat, %lstat);

sub init {
	&main::read_config('ignoredir');
	&add_wanted(\&prune_wanted);
}

sub get_stat {
	my ($file, $type) = @_;

	if ( $type eq 'lstat' ) {
		@{$lstat{$file}} = lstat($file)
			if ( ! exists $lstat{$file} );
		return @{$lstat{$file}};
	} elsif ( $type eq 'stat' ) {
		@{$stat{$file}} = stat($file)
			if ( ! exists $stat{$file} );
		return @{$stat{$file}};
	}
}

sub check {
	print ( STDERR "In Security::find::check()\n") if ( $main::opts{'d'} );

	find(\&wanted, '/');
}

sub add_wanted {
	my ($func) = @_;
	print ( STDERR "In Security::find::add_wanted()\n") if ( $main::opts{'d'} );

	@funcs = ( @funcs, $func );
}

sub prune_wanted {
	my ($file) = @_;

	for (my ($i) = 0; $i <= $#main::ignoredir; $i++) {
		if ( $main::ignoredir[$i] eq $File::Find::name ) {
			$File::Find::prune = 1;
			printf STDERR "\tPruning Tree at $File::Find::name\n" 
				if ( $main::opts{'d'} );
			return;
		}
	} 
}

sub wanted {
	for (my ($i) = 0; $i <= $#funcs; $i++) {
		&{$funcs[$i]} ($File::Find::name);
	}
}

1;
