package Security::kernel;

use Security::find;
use Exporter;
use POSIX;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() &print() );

our (%kernelperms);

sub init {
	print ( STDERR  "In Security::kernel::init()\n") if ( $main::opts{'d'} );

	&Security::find::add_wanted (\&kernel_wanted);
}

# Added $kerneldir checks based on the SANS98 Conference
sub kernel_wanted {
	if ( ! -l $File::Find::name && -f $File::Find::name ) {
		if ( defined $main::kerneldir && 
			$File::Find::name =~ /$main::kerneldir/ ) {

			my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$curbytes) = 
				&Security::find::get_stat($File::Find::name, 'lstat');

			if ( defined $Security::db::db ) {
				$Security::db::db{$File::Find::name} =
					&main::SHA1($File::Find::name);
			}

			# If the file is world writeable, then flag this case too
			$kernelperms{$File::Find::name} = 1
				if ( $mode & &S_IWOTH() );
		}
	}
}

sub print {
	print ( STDERR  "In Security::kernel::print()\n") if ( $main::opts{'d'} );

	&main::print_data ("\n\nchecking for world writable kernel modules:\n", %kernelperms);
}

1;
