package Security::owner;

use Security::find;
use Exporter;
use strict;
use warnings;

our @ISA = qw(Exporter);
our @EXPORT = qw( &init() &print() );

our (%uid, %gid, %nouids, %nogids);

sub init {
	print ( STDERR  "In Security::owner::init()\n") if ( $main::opts{'d'} );

	&Security::find::add_wanted (\&owner_wanted);

	# Load up some tables for the find to run
	setpwent;
	while (my($nm, $pw, $uid) = getpwent) {
		if ( $nm ne '+' ) {
			$uid{$nm} = $uid{$uid} = $uid;
		}
	}
	endpwent;
	setgrent;
	while (my($nm, $pw, $gid) = getgrent) {
		if ( $nm ne '+' ) {

			$gid = 4294967294
               	if ($gid == -2 &&  $^O =~ m/aix/);

			$gid{$nm} = $gid{$gid} = $gid;
		}
	}
	endgrent;
}

# Check for files that have no defined owner or group.
# From HP-UX System Security manual
sub owner_wanted {
	my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$curbytes) = 
		&Security::find::get_stat($File::Find::name, 'lstat');

	# If the file has no known owner or group, add it to that list
     $nouids{$File::Find::name} = 1
		if ( defined $uid && !defined $uid{$uid} );

     $nogids{$File::Find::name} = 1
		if ( defined $gid && !defined $gid{$gid} );
}

sub print {
	print ( STDERR  "In Security::owner::print()\n") if ( $main::opts{'d'} );

	&main::print_data ("\n\nchecking for files with no owner:\n", %nouids);
	&main::print_data ("\n\nchecking for files with no group:\n", %nogids);
}

1;
